<template>
   <div class="md:flex gap-5 flex-col md:flex-row space-y-5 md:space-y-0">
      <div v-if="currentUser.role.admin_dashboard_eligibility" class="box min-h-72 h-72 flex-1 flex-col p-5 justify-start overflow-auto bg-white rounded-lg shadow-md">
    <div class="flex items-center mb-4">
      <Icon icon="fa-solid fa-running" class="text-gray-500 text-2xl"></Icon>
      <p class="ml-4 text-lg font-semibold text-gray-700">Employees on Leave This Week</p>
    </div>
    <div v-for="la in leaveApplications" :key="la.id" class="mb-6">
      <div class="flex items-center gap-4 p-3 border-b border-gray-200">
        <Icon icon="fa-solid fa-circle-user" class="text-gray-400 text-3xl"></Icon>
        <div class="flex-1">
          <p class="text-base font-medium text-gray-800">{{ la.user.name }} ({{ la.user.role.name }})</p>
          <div class="text-sm text-gray-500 flex gap-6 mt-1">
            <div class="flex items-center gap-2">
              <Icon icon="fa-solid fa-calendar" class="text-gray-400"></Icon>
              <span>Start: {{ la.start_date }}</span>
            </div>
            <div class="flex items-center gap-2">
              <Icon icon="fa-solid fa-calendar" class="text-gray-400"></Icon>
              <span>End: {{ la.end_date }}</span>
            </div>
          </div>
        </div>
        <div class="text-sm font-semibold text-gray-600">
          {{ la.leave_type.type }}
        </div>
      </div>
    </div>
  </div>

      <!-- for upcoming birthday -->
      <div v-if="currentUser.role.admin_dashboard_eligibility" class="box min-h-72 h-72 flex-1 flex-col p-5 overflow-auto bg-white rounded-lg shadow-md">
    <div class="flex items-center mb-4">
      <Icon icon="fa-solid fa-cake-candles" class="text-gray-500 text-2xl"></Icon>
      <p class="ml-4 text-lg font-semibold text-gray-700">Upcoming Anniversaries</p>
    </div>
    <div v-for="user in computedAnniUsers" :key="user.id" class="flex justify-between items-center py-3 border-b border-gray-200">
      <div class="flex items-center gap-4">
        <Icon icon="fa-solid fa-circle-user" class="text-gray-400 text-3xl"></Icon>
        <div>
          <p class="text-base font-medium text-gray-800">{{ user.name }} ({{ user.role.name }})</p>
          <p class="text-sm text-gray-500">{{ user.doj }}</p>
        </div>
      </div>
      <div class="text-right">
        <div v-if="user.annidays === 0" class="flex items-center gap-2 text-green-500">
          <Icon icon="fa-solid fa-cake-candles" class="text-xl"></Icon>
          <p class="text-sm font-bold">Today</p>
        </div>
        <div v-else class="text-base italic text-gray-600">
          {{ user.annidays }} days to go
        </div>
      </div>
    </div>
  </div>
   </div>

   <div class="md:flex gap-5 flex-col md:flex-row space-y-5 md:space-y-0 mt-10">
      <div v-if="currentUser.can_apply_leave" class="box min-h-72 h-72 min-w-72 w-72 flex-1 flex-col p-5 overflow-auto bg-white rounded-lg shadow-md">
         <div class="flex items-center mb-4">
            <Icon icon="fa-solid fa-running"  class="text-gray-500 text-2xl"></Icon>
            <p class="ml-4 text-lg font-semibold text-gray-700">Leave Balance</p>
         </div>
         <div class="md:flex gap-x-4 flex-col md:flex-row space-y-5 md:space-y-0 mt-10 mb-3 overflow-auto">
            <div v-for="balance in user.balances" class="balance-card bg-blue-100 p-4 rounded-lg shadow-lg flex flex-col items-center justify-center w-40 h-24">
               <span class="italic text-gray-700 text-sm">{{ balance.leave_type.type }}</span>
               <span class="font-bold text-gray-800 text-base">{{ balance.balance }}</span>
            
            </div>
         </div>
      </div>

      <!-- for upcoming birthday -->
      <div class="box min-h-72 h-72 flex-1 flex-col p-5 justify-start overflow-auto">
         <div class="flex items-center gap-4">
            <Icon icon="fa-solid fa-cake-candles"  class="text-gray-500 text-2xl"></Icon>
            <p class="ml-4 text-lg font-semibold text-gray-700">Upcoming Birthdays This Week</p>
         </div>
         <!-- birdth day 1 -->
         <div class="flex justify-between items-center py-3 border-b border-gray-200" v-for="user in computedBdayUsers">
            <div>
               <div class="flex items-center gap-4">
                  <div class="text-2xl ml-1">
                     <Icon icon="fa-solid fa-circle-user"  class="text-gray-400 text-3xl">
                     </Icon>
                  </div>
                  <div>
                     <p class="text-base font-medium text-gray-800">{{ user.name }} ({{ user.role.name }})</p>
                     <p class="text-sm text-gray-500">{{ user.dob }} </p>
                  </div>
               </div>
            </div>
           
            <div class="text-right">
               <div v-if="user.bdays === 0" class="flex items-center gap-2 text-green-500">
                  <div class="text-2xl ml-1">
                     <p class="text-sm font-bold">Today</p>
                  </div>
                  <div>
                     <Icon icon="fa-solid fa-cake-candles">
                     </Icon>
                  </div>
               </div>
               <div class="text-base italic text-gray-600" v-else>
                  {{ user.bdays }} days to go
               </div>
            </div>
         </div>
      </div>
   </div>

   <div v-if="currentUser.role.admin_dashboard_eligibility"
      class="box w-full h-72 flex flex-col justify-center p-5 items-center mt-10">
      <p class="font-bold text-2xl text-gray-400 ">Total number of employee</p>
      <div class=" mt-6 flex items-center">
         <div class="text-7xl">
            <Icon icon="fa-solid fa-user-group"></Icon>
         </div>
         <div>
            <p class="text-7xl font-extrabold text-gray-400">{{ userCount }}</p>
         </div>
      </div>
      <div class="mt-5 flex gap-x-10 text-gray-400 text-3xl font-semibold">
         
      </div>
   </div>
</template>

<script setup>
import { usePage } from '@inertiajs/vue3';
import { computed } from 'vue';

const today = new Date();

const page = usePage();
const currentUser = computed(() => page.props.currentUser)

const props = defineProps({
   leaveApplications: Array,
   bdayUsers: Array,
   anniUsers: Array,
   userCount: Number,
   maleCount: Number,
   femaleCount: Number,
   user: Object
})

function getAnniDays(user) {
   return Math.ceil((new Date(user.doj).setFullYear(today.getFullYear()) - today) / (1000 * 60 * 60 * 24));
}

function getBDays(user) {
   return Math.ceil((new Date(user.dob).setFullYear(today.getFullYear()) - today) / (1000 * 60 * 60 * 24));
}

const computedBdayUsers = computed(() => props.bdayUsers.map((user) => ({ ...user, bdays: getBDays(user) })).sort((userA, userB) => userA.bdays - userB.bdays))

const computedAnniUsers = computed(() => props.anniUsers.map((user) => ({ ...user, annidays: getAnniDays(user) })).sort((userA, userB) => userA.annidays - userB.annidays))
</script>

